<%@ Page Language="C#" Title="RPS Duel" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<script runat="server" type="text/C#">
	
	enum DisplayModes
	{
		NewDuel,
		ShowNewChoices,
		ShowAllChoices,
		AcceptChallenge
	}
	
	int _currentRpsLevel;
	DisplayModes _displayMode; // = DisplayModes.ShowNewChoices;
	string _opponentUsername;
	protected override void OnLoad(EventArgs e)
	{
		_currentRpsLevel = GetUserLevel(User.Identity.Name);
		
		switch (Request.QueryString["mode"])
		{
			case "newduel":
				_displayMode = DisplayModes.NewDuel;
				_opponentUsername = Request.QueryString["username"];
				break;
			case "acceptChallenge":
				_displayMode = DisplayModes.AcceptChallenge;
				_opponentUsername = Request.QueryString["username"];
				break;
			case "newchoices":
				_displayMode = DisplayModes.ShowNewChoices;
				break;
		}
			
		
		
		setAllControls();
		DataBind();
	}
</script>
<asp:Content runat="server" ContentPlaceHolderID="HeaderContentPlaceHolder">
<script type="text/javascript">
	function findPos(obj)
	{
		var coords = { left: 0, top: 0}; 
		if (obj.offsetParent) 
		{
			coords.left = obj.offsetLeft;
			coords.top = obj.offsetTop;
			while (obj = obj.offsetParent)
			{
				coords.left += obj.offsetLeft;
				coords.top += obj.offsetTop;
			}
		}
		return coords;
	}
	
	var NUM_STEPS = 40;

	function selectnew(img, newSrc)
	{
		var imgPos = findPos(img);

		var newImg = document.createElement("img");
		newImg.id = img.id + "__zoomImg";
		newImg.src = newSrc;
		newImg.style.position = "absolute";
		//newImg.style.filter += " alpha(opacity=50)";
		//newImg.style.opacity = .5;
		img.src = '/i/spacer.gif';
		img.parentNode.insertBefore(newImg,img);
		imgZoom(img.id, newImg.id, NUM_STEPS);
	}
	
	function imgZoom(imgId, newImgId, step)
	{
		var img = document.getElementById(imgId);
		var newImg = document.getElementById(newImgId);
		var imgPos = findPos(img);
		
		if (step <= 1)
		{
			newImg.style.display = 'none';
			img.style.display = 'inline';
			img.src = newImg.src;
			img.onclick = "";
			img.style.cursor = "";
			
			var txt = document.createElement("div");
			txt.id = img.id + "__zoomTxt";
			txt.innerHTML = img.alt;

			txt.style.position = "absolute";
			txt.style.width = ((imgPos.left * 2) + img.width) + "px";
			txt.style.left = 0;
			txt.style.fontSize = "1px";
			txt.style.fontFamily = "Times New Roman, Serif";
			txt.style.textAlign = "center";
			img.parentNode.insertBefore(txt,img);
			txtZoom(img.id, txt.id, NUM_STEPS);
			
		}
		else
		{
			var pct = step / NUM_STEPS;
			newImg.height = img.height * step;
			newImg.width = img.width * step;
			newImg.style.top = (imgPos.top - newImg.height / 2) + (img.height / 2);
			newImg.style.left = (imgPos.left - newImg.width / 2) + (img.width / 2);
			if (step >= 25) step -= 5;
			else if (step >= 10) step -= 2;
			else step -= 1;
			setTimeout("imgZoom('" + img.id + "', '" + newImg.id + "'," + (step) + ");", 20);
		}
	}
	
	function txtZoom(imgId, txtId, step)
	{
		var img = document.getElementById(imgId);
		var txt = document.getElementById(txtId);
		var imgPos = findPos(img);

		var invStep = (NUM_STEPS - step) + 1;
		txt.style.top = imgPos.top - invStep * 4;
		txt.style.fontSize = (invStep * 5) + "px";
		window.status = invStep;
		
		if (step <= 0)
		{
			txt.style.display = "none";
		}		
		else if (step == 1)
		{
			setTimeout("txtZoom('" + img.id + "', '" + txt.id + "', " + (step-1) + ");", 1000);
		}
		else
		{
			setTimeout("txtZoom('" + img.id + "', '" + txt.id + "', " + (step-1) + ");", 20);
		}
	}
</script>
</asp:Content>
<asp:Content ContentPlaceHolderID="MainContentPlaceHolder" Runat="Server">
<form runat="server">
<h1><a href="../../">My Stuff</a> &raquo; <a href="../">Duels</a> &raquo;<span> RPS</span></h1>
<p runat="server" visible="<%#_displayMode == DisplayModes.ShowNewChoices %>">
Congratulations! You've unlocked new RPS choices. Click on them to reveal what 
they are.</p>
<p runat="server" visible="<%#_displayMode == DisplayModes.NewDuel %>">
So you want to challenge <%#_opponentUsername%> to a duel, eh? Well, first things first, 
select your gesture. On the next page, you will confirm the choice and select how many points 
you'd like to wager.</p>
<p runat="server" visible="<%#_displayMode == DisplayModes.AcceptChallenge %>">
Wise move. <em><%#_opponentUsername%></em> has been bullying everyone around enough with duel
challenges. Now show <em><%#_opponentUsername%></em> who's the boss and make your selection.</p>
<table border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td></td>
		<td></td>
		<td></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/nuke.gif" ID="_choiceImage_nuke" Width="72" Height="72" /></td>
		<td></td>
		<td></td>
		<td></td>
		<td></td>
	</tr>
	<tr>
		<td></td>
		<td></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/lightning.gif" ID="_choiceImage_lightning" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/snake.gif" ID="_choiceImage_snake" Width="72" Height="72" /></td>
		<td></td>
		<td></td>
		<td></td>
	</tr>
	<tr>
		<td></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/devil.gif" ID="_choiceImage_devil" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/gun.gif" ID="_choiceImage_gun" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/wolf.gif" ID="_choiceImage_wolf" Width="72" Height="72" /></td>
		<td></td>
		<td></td>
	</tr>
	<tr>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/woman.gif" ID="_choiceImage_woman" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/rock.gif" ID="_choiceImage_rock" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/paper.gif" ID="_choiceImage_paper" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/dynamite.gif" ID="_choiceImage_dynamite" Width="72" Height="72" /></td>
		<td></td>
	</tr>
	<tr>
		<td><asp:Image runat="server" ImageUrl="images/axe.gif" ID="_choiceImage_axe" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/sponge.gif" ID="_choiceImage_sponge" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/scissors.gif" ID="_choiceImage_scissors" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/water.gif" ID="_choiceImage_water" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/bowl.gif" ID="_choiceImage_bowl" Width="72" Height="72" /></td>
	</tr>
	<tr>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/cockroach.gif" ID="_choiceImage_cockroach" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/air.gif" ID="_choiceImage_air" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/fire.gif" ID="_choiceImage_fire" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/alien.gif" ID="_choiceImage_alien" Width="72" Height="72" /></td>
		<td></td>
	</tr>
	<tr>
		<td></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/dragon.gif" ID="_choiceImage_dragon" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/man.gif" ID="_choiceImage_man" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/tree.gif" ID="_choiceImage_tree" Width="72" Height="72" /></td>
		<td></td>
		<td></td>
	</tr>
	<tr>
		<td></td>
		<td></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/monkey.gif" ID="_choiceImage_monkey" Width="72" Height="72" /></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/moon.gif" ID="_choiceImage_moon" Width="72" Height="72" /></td>
		<td></td>
		<td></td>
		<td></td>
	</tr>
	<tr>
		<td></td>
		<td></td>
		<td></td>
		<td></td>
		<td><asp:Image runat="server" ImageUrl="images/sun.gif" ID="_choiceImage_sun" Width="72" Height="72" /></td>
		<td></td>
		<td></td>
		<td></td>
		<td></td>
	</tr>
</table>
<p runat="server" visible="<%#_currentRpsLevel < 25 %>">
Curious what's up with all the question marks? As you gain more experience points on the site, you will
gain more choices. Every fifty points you earn gets you two more choices.
</p>
<p runat="server" visible="<%#_displayMode == DisplayModes.ShowNewChoices %>">
<input type="button" onclick="location='/my/duels/'" value="Go Challenge Someone To A Duel" />
&nbsp;
<input type="button" onclick="location='/my/'" value="Take Me To MyStuff" />
</p>
<p runat="server" visible="<%#_displayMode == DisplayModes.NewDuel %>">
<input type="button" onclick="location='../'" value="Err, I've changed my mind ..." /></p>
</form>
</asp:Content>

<script runat="server" type="text/C#">
	void setAllControls()
	{
		//SELECT 'setControl(this._choiceImage_' + Choice_Name + ', '
		//         + '"' + [Choice_Name] + '", ' + 
		//         + CAST([Choice_Level] AS VARCHAR(2)) + ');'
		//  FROM [Duel_RpsChoices]	
		setControl(this._choiceImage_air, "air", 5);
		setControl(this._choiceImage_alien, "alien", 21);
		setControl(this._choiceImage_axe, "axe", 19);
		setControl(this._choiceImage_bowl, "bowl", 19);
		setControl(this._choiceImage_cockroach, "cockroach", 23);
		setControl(this._choiceImage_devil, "devil", 11);
		setControl(this._choiceImage_dragon, "dragon", 13);
		setControl(this._choiceImage_dynamite, "dynamite", 23);
		setControl(this._choiceImage_fire, "fire", 5);
		setControl(this._choiceImage_gun, "gun", 9);
		setControl(this._choiceImage_lightning, "lightning", 15);
		setControl(this._choiceImage_man, "man", 9);
		setControl(this._choiceImage_monkey, "monkey", 17);
		setControl(this._choiceImage_moon, "moon", 17);
		setControl(this._choiceImage_nuke, "nuke", 25);
		setControl(this._choiceImage_paper, "paper", 3);
		setControl(this._choiceImage_rock, "rock", 3);
		setControl(this._choiceImage_scissors, "scissors", 3);
		setControl(this._choiceImage_snake, "snake", 15);
		setControl(this._choiceImage_sponge, "sponge", 7);
		setControl(this._choiceImage_sun, "sun", 25);
		setControl(this._choiceImage_tree, "tree", 13);
		setControl(this._choiceImage_water, "water", 7);
		setControl(this._choiceImage_wolf, "wolf", 11);
		setControl(this._choiceImage_woman, "woman", 21);
	}
	void setControl(Image ctrl, string name, int lvl)
	{
		int prevLev = lvl - 2;
		
		if (_currentRpsLevel < lvl)
		{
			ctrl.ImageUrl = "images/unknown.gif";
			ctrl.AlternateText = "???";
		}
		else if (_displayMode == DisplayModes.ShowNewChoices && _currentRpsLevel == lvl && _currentRpsLevel > 3)
		{
			ctrl.Attributes.Add("onclick", "selectnew(this,'" + ctrl.ImageUrl + "');");
			ctrl.ImageUrl = "images/new.gif";
			ctrl.Style.Add(HtmlTextWriterStyle.Cursor, "hand");
			ctrl.AlternateText = name;
		}
		else if (_displayMode == DisplayModes.NewDuel)
		{
			ctrl.Attributes.Add("onclick", "location='newDuel.aspx?choice=" + name + "&username=" + _opponentUsername + "';");
			ctrl.Style.Add(HtmlTextWriterStyle.Cursor, "hand");
			ctrl.AlternateText = name;
		}
		else if (_displayMode == DisplayModes.AcceptChallenge)
		{
			ctrl.Attributes.Add("onclick", "if (confirm('Are you sure you want to choose " + name + "?')) location='acceptDuel.asp?duelId=" + Request.QueryString["DuelId"] + "&choice=" + name + "';");
			ctrl.Style.Add(HtmlTextWriterStyle.Cursor, "hand");
			ctrl.AlternateText = name;			
		}
		else
		{
			ctrl.AlternateText = name;
		}
        ctrl.ToolTip = ctrl.AlternateText;
	}

	int GetUserLevel(string username)
	{
		//Duel_RpsGetUserLevel
		using (SqlCommand cmd = new SqlCommand())
		{
			cmd.Connection = new SqlConnection(ConfigurationManager.ConnectionStrings["ChooseYourStory"].ConnectionString);

			cmd.CommandText = ChooseYourStory.Data.StoredProcedures.Duel_RpsGetUserLevel;
			cmd.CommandType = CommandType.StoredProcedure;
			cmd.Parameters.Add("@User_Username", SqlDbType.VarChar, 30).Value = username;
			cmd.Parameters.Add("@User_Level", SqlDbType.Int).Direction = ParameterDirection.Output;
			try
			{
				cmd.Connection.Open();
				cmd.ExecuteNonQuery();
				return (int)cmd.Parameters["@User_Level"].Value;
			}
			finally
			{
				cmd.Connection.Close();
			}
		}		
	}
</script>


